var _avalon = avalon.define({
    $id: 'pagecontroller',
    sceneName: 'main',
    sceneStack: ['main'],   //场景堆栈（当前场景显示在最后面）
    params: null,           //传入的参数
    searchParams: {},
    pageData: {
    	list: [],
    	currentPage: 1,
    	lastPage : 1,
    	listRows : 10,
    	total : 10,
    	url : "",
    },
    selectedItems: [],	//选择项
    selectedAmount: 0,	//选择项金额
    totalCredit: 0,		//总欠款
    userName: '',		//客户/货主名称
    
    //场景
    repayment: null,
    
    keyup: function(keyCode){
        switch(keyCode){
            case 120://F9
                $('.main-keyup-f9').trigger('click');
                break;
            case 122://F11
                $('.main-keyup-f11').trigger('click');
                break;
        }
    },
    
    //获取列表
    getList: function(url){
    	var _av = this;
    	if( !url ) url = _av.params.main_url;
    	window.request('get', url, this.searchParams, false, function(data){
        	if( !data.code || data.code != 1 ){
				return Alert(data.message ? data.message : '获取数据失败');
			}
			_av.pageData = data.data;
			
			//获取客户或货主名称和欠款
			var userdata = data.data.customer ? data.data.customer : data.data.supplier;
			_av.totalCredit = parseFloat(Math.abs(userdata.balance).toFixed(2));
			_av.userName = userdata.label_name + ' ' + userdata.name;
			
			//重置已选项
			_av.selectedItems = [];
			_av.selectedAmount = 0;
			$('input[name="credit-ids"]').attr("checked", false);
    	});
    },
    
    //选择欠款项
    selectItem: function(event, id, amount){
    	if( event.currentTarget.checked ){
    		this.selectedItems.push(id);
    		this.selectedAmount = floatadd(this.selectedAmount, amount);
    	}else{
    		var index = $.inArray(id, this.selectedItems);
    		if( index >= 0 ){
    			this.selectedItems.splice(index, 1);
    			this.selectedAmount = floatsub(this.selectedAmount, amount);
    		}
    	}
    },
    
    repaymentPopup: function(){
    	this.repayment.into('', this.selectedItems);
    },
    
    //上一页
    pageup: function(){
    	if( this.pageData.currentPage <= 1 ) return;
    	this.pageData.currentPage--;
    	this.getList(this.pageData.url.replace('{%page%}', this.pageData.currentPage));
    },
    
	//下一页
    pagedown: function(){
    	if( this.pageData.currentPage >= this.pageData.lastPage ) return;
    	this.pageData.currentPage++;
    	this.getList(this.pageData.url.replace('{%page%}',  this.pageData.currentPage));
    },
    
    //初始化
    init: function(){
    	var _av = this;
        $(window).on('avalon-start', function(e, data){
            //开始
            _av.params = data;
            
            //还款
            _av.repayment.init(_av, _av.params.repayment_url, function(data){
                if(data) _av.getList();
            });
            
            _av.getList(_av.params.main_url);
        })
        .on('popup-show-click', function(e, data){
            //进入场景
            var $popup = $(data.popupname)
            _av[$popup.data('scene')].into($popup.get(0));
        })
        .on('popup-mask-click', function(e, data){
            //退出场景
            _av[ $(data.popup).data('scene') ].exit( data.popup );
        })
        .on('keyup', function(e){
            //事件分别进入到当前场景的处理函数
            var sceneName = _av.sceneStack[_av.sceneStack.length-1];
            if( _av.sceneName == sceneName ){
                _av.keyup(e.keyCode);

            }else if( _av[sceneName] && _av[sceneName].sceneName == sceneName ){
                _av[sceneName].keyup(e.keyCode);
            }
            e.keyCode=0;
            e.returnValue = false;
        });
    }
});
//还款层
_avalon.repayment = {
    sceneName: 'repayment',
    url: '',
    callback: null,
    ids: [],
    
    //铵钮处理
    keyup: function(keyCode){
        switch(keyCode){
            case 13://ENTER
                this.formSubmit();
                break;
            case 27://ESC
                this.exit();
                break;              
        }
    },
    
    //进入
    into: function(popup, ids){
        var $popup = popup ? $(popup) : $('#repayment-popup');
        $popup.show();
        if( window.device=='ios' ) $('body').addClass('ios-popup-fixed');
        if( window.device!='ios' || window.pack!='app') $popup.find('input[name="label"]').focus();
        _avalon.sceneStack.push(this.sceneName);
        this.ids = ids;
    },
    
    //退出
    exit: function(popup, data){
        var $popup = popup ? $(popup) : $('#repayment-popup');
        $popup.hide();
        if( window.device=='ios' ) $('body').removeClass('ios-popup-fixed');
        if( window.device=='ios' && window.pack=='app' && (document.activeElement.nodeName == 'INPUT' || document.activeElement.nodeName == 'SELECT' || document.activeElement.nodeName == 'TEXTAREA') ) document.activeElement.blur();
        //$('form[name="repayment-form"]').get(0).reset(); 
        _avalon.sceneStack.pop();
        if( typeof(this.callback) == 'function' ){
            this.callback(data);
        }
    },
    
    //提交表单
    formSubmit: function(){
        var _this = this;
        var $form = $('form[name="repayment-form"]'),
            formdata = {
        		userid: parseInt( $form.find('input[name="userid"]').val() ),
        		total: parseFloat( $form.find('input[name="total_credit"]').val().replace('¥', '') ),
        		amount: parseFloat( $form.find('input[name="repayment_amount"]').val().replace('¥', '') ),
        		note: $form.find('input[name="note"]').val()
            };
        
        //验证
        if( isNaN(formdata.amount) || formdata.amount<=0 || isNaN(formdata.total) || formdata.total<=0 || formdata.total<formdata.amount ){
            return Alert('还款金额有误');
        }
        formdata.ids = this.ids.join(',');
        
        var $btn = $('#repayment-btn-submit');
        $btn.button('loading');
        window.request('post', _avalon.params.repayment_url, formdata, false, function(data){
        	$btn.button('reset');
        	if( !data.code || data.code != 1 ){
                return Alert(data.message ? data.message : '操作失败');
            }
            
            Alert('还款成功');
            if( window.settings && window.settings.customer_repayment_print == 1 ){
            	toPrint('customer_repayment', {id:data.data.repayment_id}); 
            }
            _this.exit('', formdata);
        });
    },
    
    //初始化
    init: function(av, url, callback){
        var _this = this;
        _this.url = url;
        _this.callback = callback;
        $('#repayment-btn-submit').click(function(){
            _this.formSubmit();
        });
        $('#repayment-btn-cancel').click(function(){
            _this.exit();
        });
    }
};
_avalon.init();