avalon.filters.showtitle = function(txt){
    if( !txt ){
        return "散户";
    }
    return txt.replace(' ', '<br/>');
};
var _avalon = avalon.define({
    $id: 'pagecontroller',
    ready: false,
    sceneName: 'main',
    sceneStack: ['main'],   //场景堆栈（当前场景显示在最后面）
    params: null,           //传入的参数
    orderList: [],          //订单（包括临时订单）
    orderIndex: 0,          //当前所显示订单的索引
    goodsList: [],			//商品列表
    activeOrder: {
    	orderId:0, goodsList:[], customerId:0, customerName:'', ispickup: 0
    },
    selectGoodsSwiper: null,
    sideswitchSwiper: null,
    modifyIndex: -1,		//修改商品的索引
    activeUserBalance: 0, //当前客户的余额
    
    selectuser: null,
    settlement: null,
    addgoods: null,
    adduser: null,
    selectorders: null,
    
    
    
    keyup: function(keyCode){
        switch(keyCode){
	        case 112://F1
	        	this.addNewTempOrder();
	            break;
	        case 113://F2
                $('.main-keyup-f2').trigger('click');
                break;
            case 114://F3
                $('.main-keyup-f3').trigger('click');
                break;
            case 115://F4
                if( this.activeOrder.goodsList.length ){
                    this.saveToServer();
                }
                break;
        }
    },
    
    moreOrder: function(){
    	this.selectorders.into();
    },
    
    //显示订单
    showOrder: function(){
    	if( this.orderList.length == 0 ){
    		this.addNewTempOrder();
    	}
    	if( this.orderList.length <= this.orderIndex ){
    		this.orderIndex = this.orderList.length - 1;
    	}
    	this.activeOrder = this.orderList[this.orderIndex];
    },
    
    //保存OrderId
    saveOrderId: function(orderId){
        this.orderList[this.orderIndex].orderId = orderId;
        this.showOrder();
        this.saveOrderToLocalStorage();
    },
    
    //切换订单
    changeOrder: function(index, ismore){
    	if( this.orderList.length>this.activeSideOrderSize && index >= this.activeSideOrderSize-1 ){
    		var orders = this.orderList.splice(index, 1);
    		this.orderList.unshift( orders[0] );
    		this.orderIndex = 0;
    		this.selectorders.exit();
    		this.updateOrderNameSwiper();
    	}else{
    		this.orderIndex = typeof(index) == 'undefined' ? this.orderIndex : index;
    	}
        this.activeOrder = this.orderList[this.orderIndex];
        if( this.activeOrder.orderId > 0 && !this.activeOrder.isServerData ){
            //服务器存在，但未获取服务器数据时
            this.getServerOrderDetail( this.activeOrder.orderId );
        }
        $('.side-switch li:eq('+this.orderIndex+')').addClass('active').siblings().removeClass('active');
        
        this.updateFootTotal();
        this.saveOrderToLocalStorage();
        this.showUserBalance(this.activeOrder.customerId);
    },
    
    //添加新临时订单
    addNewTempOrder: function(isSaveToStorage){
    	if( this.orderList.length>0 && this.orderList[0].orderId==0 && this.orderList[0].customerId==0 && this.orderList[0].goodsList.length==0 ){
    		//有空白订单，不用新增
    	}else{
    		this.orderList.unshift({orderId:0, goodsList:[], customerId:0, customerName:'', ispickup:0});
    	}
        this.orderIndex  = 0;
        this.activeOrder = this.orderList[this.orderIndex];
        if( isSaveToStorage ){
            this.saveOrderToLocalStorage();
        }
        this.updateOrderNameSwiper();
    },
    
    //显示用户余额
    showUserBalance: function(id){
    	var av = this;
    	av.activeUserBalance = 0;
    	
    	if( !id ) return;
    	
    	window.request('get', this.params.userbalance_url, {id:id}, false, function(data){        	
    		if( !data.code || data.code != 1 ){
    			return;
            }
    		av.activeUserBalance = parseFloat(data.data);
    	});
    },
    
    //
    setUserFun: function(id, name){
    	var av = this;
    	var oldId   = this.orderList[ this.orderIndex ].customerId;
    	var oldName = this.orderList[ this.orderIndex ].customerName;
        this.orderList[ this.orderIndex ].customerId = id;
        this.orderList[ this.orderIndex ].customerName = name;
        if( this.activeOrder.orderId > 0 ){
            //更新到服务器
        	window.request('post', this.params.setcustomer_url, {
        		order_id:this.orderList[ this.orderIndex ].orderId, 
        		customer_id:id
        	}, false, function(data){        	
        		if( !data.code || data.code != 1 ){
        			Alert(data.message ? data.message : '操作失败');
        			
                    //本地数据回滚
        			av.orderList[ this.orderIndex ].customerId = idoldId;
        			av.orderList[ this.orderIndex ].customerName = oldName;
        			av.showOrder();
        			av.saveOrderToLocalStorage();
                }
        	});
        }
        this.showUserBalance(id);
        this.showOrder();
        this.saveOrderToLocalStorage();
    },
    
    //设置货主
    setUser: function(id, name){
    	var av = this;
    	
    	//该客户是否已有订单
    	if( id>0 ){
	    	for( var i=0; i<this.orderList.length; i++ ){
	    		if( this.orderList[i].customerId == id ){
	    			if( this.orderIndex != i ){
	    				Confirm('此客户已有未结算订单，是否立即编辑?', function(isok){
	    					if( !isok ){
	    						return;
	    					}
	    					av.changeOrder(i);
	    				});
	    			}
	    			return;
	    		}
	    	}
    	}
    	
    	//如果更换客户名进行提示
    	if( this.orderList[ this.orderIndex ].customerId>0 ){
    		Confirm('您确定要更换此订单客户码?', function(isok){
				if( !isok ){
					return;
				}
				av.setUserFun(id, name);
			});
    		return;
    	}
    	
    	av.setUserFun(id, name);
    },
    
    //更新订单名和切换
    activeSideOrderSize : 0,
    activeWindowWidth : 0,
    updateOrderNameSwiper: function(){
        /*if( !this.sideswitchSwiper ){
            var p = {
                pagination: '.swiper-pagination',
                slidesPerView: 'auto',
                paginationClickable: true,
                freeMode: true
            };
            if( $(window).width() > 767 ) p.direction = 'vertical';
            this.sideswitchSwiper = new Swiper('.side-switch .lists', p);
        }else{
            this.sideswitchSwiper.update();
        }*/
    	var winwidth = $(window).width();
    	var winheight = $(window).height();
    	if( winwidth > 768 ){
    		if( this.activeWindowWidth <= 768 ){
    			$('.side-switch li').attr('style', '');
    		}
    		this.activeWindowWidth = winwidth;
	        var top = $('.side-switch .lists').offset().top;
	        var lihei = 80;
	        var size = Math.floor((winheight - top) / lihei); 
	        //if( size == this.activeSideOrderSize ){
	        //	return;
	        //}
	        this.activeSideOrderSize = size;
	        if( this.activeSideOrderSize < this.orderList.length ){
	        	$('.side-switch li').css('height', (winheight - top - lihei)/(this.activeSideOrderSize - 1));
	        	$('.side-switch .more').show();
	        	$('.order-lis-more li').show().slice(0, this.activeSideOrderSize-1).hide();
	        }else{
	        	$('.side-switch .more').hide();
	        }
    	}else{
    		if( this.activeWindowWidth > 768 ){
    			$('.side-switch li').attr('style', '');
    		}
    		this.activeWindowWidth = winwidth;
    		var left = $('.side-switch .lists').offset().left;
	        var lihei = 70;
	        var size = Math.floor((winwidth - left) / lihei); 
	        //if( size == this.activeSideOrderSize ){
	        //	return;
	        //}
	        this.activeSideOrderSize = size;
	        if( this.activeSideOrderSize < this.orderList.length ){
	        	$('.side-switch li').css('width', (winwidth - left - lihei)/(this.activeSideOrderSize - 1));
	        	$('.side-switch .more').show();
	        	$('.order-lis-more li').show().slice(0, this.activeSideOrderSize-1).hide();
	        }else{
	        	$('.side-switch .more').hide();
	        }
    	}
    },
    
    //更新选择商品
    updateSelectGoodsSwiper: function(){
    	if( !this.selectGoodsSwiper ){
            var p = {
                    scrollbar: '.swiper-scrollbar',
                    direction: 'vertical',
                    slidesPerView: 'auto',
                    mousewheelControl: true,
                    freeMode: true,
            		roundLengths : true, //防止文字模糊
                };
            this.selectGoodsSwiper = new Swiper('.select-product > .wrap', p);
        }else{
            this.selectGoodsSwiper.update();
        }
    },
    
    //存储订单列表
    saveOrderToLocalStorage: function(){
        localStorage.setItem('orderList'+window.memberId, JSON.stringify(this.orderList));
        localStorage.setItem('orderIndex'+window.memberId, this.orderIndex);
    },
    
    //从本地获取订单
    getOrderListFromLocalStorage: function(){        
        var data    = localStorage.getItem('orderList'+window.memberId);
        var index   = localStorage.getItem('orderIndex'+window.memberId);
        if( typeof(data) == 'undefined' || !data ){
            this.orderList = [];
        }else{
            this.orderList = JSON.parse(data);
        }
        this.orderIndex = typeof(index) == 'undefined' || index == null ? this.orderList.length - 1 : parseInt(index);
        //this.orderIndex = 0;
        this.orderIndex = Math.max(Math.min(this.orderIndex, this.orderList.length-1), 0);
        if(this.orderList.length==0) this.addNewTempOrder(false);
        this.updateFootTotal();
    },
    
    //更新本地订单列表
    updateLocalOrderList: function(list){
        var i, n, listOrderIdArr=[];
        for( i=0; i<list.length; i++ ){
            var isfind = false;
            listOrderIdArr.push(list[i].id);
            for( n=0; n<this.orderList.length; n++){
                if( this.orderList[n].orderId == list[i].id ){
                    //查找到本地存在该订单
                    this.orderList[n].updated = true;
                    this.orderList[n].customerId = list[i].customer_id;
                    this.orderList[n].customerName = list[i].customer_name;
                    //this.orderList[n].customer_id = list[i].is_pickup;
                    isfind = true;
                    
                    //如果找到的就是当前的查看的订单，就立即获取订单详细
                    this.getServerOrderDetail(list[i].id);
                    break;
                }
            }
            
            if( !isfind ){
                //本地未找到该订单，就添加进来
                this.orderList.push({
                    orderId:      list[i].id,
                    customerId:   list[i].customer_id,
                    customerName: list[i].customer_name,
                    //ispickup:	  list[i].is_pickup,
                    goodsList:    [],
                });
            }
        }
        
        //删除服务器上没有的订单
        for( n=0; n<this.orderList.length; n++){
            if( this.orderList[n].orderId > 0 && $.inArray(this.orderList[n].orderId, listOrderIdArr) === -1 ){
                this.removeOrder(n, false);
            }
        }
        
        //判断是否为当前显示的（获取详细）
        if( this.activeOrder.orderId > 0 && this.activeOrder.isServerData == false ){
            this.getServerOrderDetail( this.activeOrder.orderId );
        }
    },
    
    //获取服务器上订单详细
    getServerOrderDetail: function(orderId){
        var _av = this;
        //从网络获取订单列表
        window.request('get', _av.params.order_detail_url, {id:orderId}, false, function(data){        	
    		if( !data.code || data.code != 1 ){
                return Alert(data.message ? data.message : '获取订单失败');
            }
            
            //更新本地预订的列表
            for( var i=0; i < _av.orderList.length; i++ ){
                if( _av.orderList[i].orderId == orderId ){
                	//for( var n=0; n<data.data.goods_list.length; n++ ){
                	//	data.data.goods_list[n].reduce_price = 0;
                	//}
                    _av.orderList[i].goodsList = data.data.goods_list;
                    _av.orderList[i].ispickup = data.data.order.is_pickup;
                    _av.orderList[i].isServerData = true;//已从服务器获取详细信息
                    if( _av.orderIndex == i ){
                        _av.changeOrder(_av.orderIndex);
                    }
                    break;
                }
            }
        });
    },
    
    //显示商品列表
    showGoodsList: function(){
        if( this.activeOrder.goodsList.length > 0 ){
            setTimeout(function(){
                $('.m-stockgoods-list li').swiper({
                    slidesPerView: 'auto', 
                    resistanceRatio: .00000000000001, 
                    slideToClickedSlide: true,
                });
            }, 500);            
        }
    },
    
    //删除订单前的提示
    removeOrderConfirm: function(){
        if( this.activeOrder.goodsList.length == 0 ){
            return _avalon.removeOrder(_avalon.orderIndex, true);
        }
        Confirm('您确定要删除此订单吗?', function(isok){
            if( isok ){
                _avalon.removeOrder(_avalon.orderIndex, true);
            }
        }); 
    },
    
    //删除订单
    removeOrder: function(index, isremoveserver){
    	var _av = this;
    	//小于等于就索引退一个
        if( this.orderIndex <= index && this.orderIndex>0 ){
            this.orderIndex--;
        }
        var order = this.orderList.splice(index, 1)[0];
        if( order.orderId > 0 && isremoveserver ){
            //删除服务器上
        	window.request('post', this.params.cancelorder_url, {order_id:order.orderId}, false, function(data){        	
        		if( !data.code || data.code != 1 ){
                    return Alert(data.message ? data.message : '操作失败', 500, function(){});
                }
        		_av.getstockList();
                //Alert('删除成功');
            });
        }
        
        this.showOrder();
        this.changeOrder(this.orderIndex);
        this.saveOrderToLocalStorage();
        this.updateOrderNameSwiper();
    },
    
    //入库提交到服务器
    saveToServer: function(e){
    	var $btn = $('#btn-footer-submit');
    	if( $btn.data('loading') ){
    		return;
    	}
    	
        var _av = this;
        if( _av.activeOrder.orderId > 0 ){
            //显示结算层
            $(window).trigger('popup-show-click', {popupname:'#settlement-popup'});
            return;
        }
        
        
        $btn.data('loading', true);
        window.request('post', _av.params.save_url, {
            customer_id: _av.activeOrder.customerId,
            order_id: _av.activeOrder.orderId,
            goods_list: JSON.stringify(_av.activeOrder.goodsList)
        }, false, function(data){
        	$btn.data('loading', false);
            if( !data.code || data.code != 1 ){
                return Alert(data.message ? data.message : '操作失败');
            }
            
            Alert('订单保存成功');
            _av.saveOrderId(parseInt(data.data.order_id));
            _av.getstockList();
        });
        return false;
    },

    
    stockList: [],
    selectData: [],
    getstockList: function(){
        var _this = this;
        
        //获取所有库存
        window.request('get', _avalon.params.selectstock_url, {}, true, function(data){
        	_this.ready = true;
        	if( !data.code || data.code != 1 ){
                 return Alert(data.message ? data.message : '获取货主数据失败');
             }
             _this.stockList = data.data;
             
             _this.selectData = [];
             if( !$.isEmptyObject(_this.stockList) ){
	             for( var stockId in _this.stockList ){
	                 _this.selectData.push({
	                     id: stockId, 
	                     value:_this.stockList[stockId].stock_title ? _this.stockList[stockId].stock_title : _this.stockList[stockId].supplier_name + ' 第' + _this.stockList[stockId].supplier_sort + '车', 
	                     children: _this.stockList[stockId].children
	                 });
	             }
             }
             
             $('#selectinput-stock-goods').selectpicker('val', ['Mustard','Relish']);//.select2();
             
             _this.updateSelectGoodsSwiper();
        });
    },

	//更新下部总数
    updateFootTotal: function(){
        var goodsTotal = 0,
            handlingfeeTotal = 0,
            goodsList = _avalon.orderList[_avalon.orderIndex].goodsList;
        for( var i=0; i<goodsList.length; i++ ){
            if( goodsList[i].unit == 'JIN' ){
                goodsTotal += Math.round(goodsList[i].price * 100) * goodsList[i].weight;
                handlingfeeTotal += Math.round(goodsList[i].handling_fee * 100) * goodsList[i].weight;
            }else if(goodsList[i].unit == 'BOXES'){
                goodsTotal += Math.round(goodsList[i].price * 100) * goodsList[i].boxes;
                handlingfeeTotal += Math.round(goodsList[i].handling_fee * 100) * goodsList[i].boxes;
            }else{
            	goodsTotal += Math.round(goodsList[i].price * 100) * goodsList[i].weight;
                handlingfeeTotal += Math.round(goodsList[i].handling_fee * 100) * goodsList[i].boxes;
            }
        }
        $('#foot-addto').html('&yen;'+goodsTotal/100);
        $('#foot-handlingfee').html('&yen;'+handlingfeeTotal/100);
        $('#foot-total').html((goodsTotal+ handlingfeeTotal)/100);
        
        this.showGoodsList();
    },
    
    //修改是否取货
    setPickup: function(orderId, event){
    	var _av = this;
    	var ispickup = event.currentTarget.checked ? 1 : 0;
    	window.request('post', _av.params.modifypickup_url, {order_id: orderId, is_pickup:ispickup}, false, function(data){
    		if( !data.code || data.code != 1 ){
    			_av.activeOrder.ispickup = ispickup ? 0 : 1;
                return Alert(data.message ? data.message : '操作失败');
            }
    		_av.orderList[_av.orderIndex].ispickup = ispickup;
    		_av.showOrder();
        });
    },
    
	//添加一个商品
    addGoodsFun: function(formdata){
    	var _av = this;
    	_av.orderList[_av.orderIndex].goodsList.push(formdata);
    	_av.showOrder();
        _av.updateFootTotal();
        _av.saveOrderToLocalStorage();
        
        //如果为已订订单，就修改服务器
        if( _av.activeOrder.orderId > 0 ){
            formdata.order_id = _av.activeOrder.orderId;
            
            window.request('post', _av.params.addgoods_url, formdata, false, function(data){
        		if( !data.code || data.code != 1 ){
                    //失败就要删除此数据
                    for( var i=0; i<_av.activeOrder.goodsList.length; i++ ){
                        if( _av.activeOrder.goodsList[i].stock_goods_id == formdata.stock_goods_id ){
                            _av.activeOrder.goodsList.splice(i, 1);
                        }
                    }
                    return Alert(data.message ? data.message : '操作失败');
                }
        		_av.getstockList();
                //Alert('添加成功');
            });
        }
    },
    
    //修改商品
    modifyGoodsFun: function(formdata){
    	var _av = this;
        //取出原数据，在更新服务器失败时要恢复
        var olddata = _av.activeOrder.goodsList[this.modifyIndex];
        //设置新数据
        _av.orderList[_av.orderIndex].goodsList[this.modifyIndex].boxes = formdata.boxes;
        _av.orderList[_av.orderIndex].goodsList[this.modifyIndex].weight = formdata.weight;
        _av.orderList[_av.orderIndex].goodsList[this.modifyIndex].price = formdata.price;
        _av.orderList[_av.orderIndex].goodsList[this.modifyIndex].handling_fee = formdata.handling_fee;
        _av.showOrder();
        _av.updateFootTotal();
        _av.saveOrderToLocalStorage();
        
        //如果为已订订单，就修改服务器
        if( _av.activeOrder.orderId > 0 ){
            formdata.order_id = _av.activeOrder.orderId;
            
            window.request('post', _av.params.modifygoods_url, formdata, false, function(data){
        		if( !data.code || data.code != 1 ){
                    //失败就要恢复原数据
                    for( var i=0; i<_av.activeOrder.goodsList; i++ ){
                        if( _av.activeOrder.goodsList[i].stock_goods_id == formdata.stock_goods_id ){
                            _av.orderList[_av.orderIndex].goodsList[i] = olddata;
                            _av.showOrder();
                        }
                    }                            
                    return Alert(data.message ? data.message : '操作失败');
                }
        		_av.getstockList();
                //Alert('修改成功');
            });
        }
    },
    
    //从则边选择了商品
    selectgoodsForSide: function(id, unit, surplus_weight, surplus_boxes, price, handling_fee){
    	this.modifyIndex = -1;
    	this.addgoods.selectgoodsForSide(id, unit, surplus_weight, surplus_boxes, price, handling_fee);
    },
    
	//修改商品
    modifyGoodsItem: function(index){
    	this.modifyIndex = index;
    	this.addgoods.modifyGoodsItem(this.activeOrder.goodsList[index]); 
    },
    
    //优惠下车费到单价
    freeHandlingFeeGoodsItem: function(index){
    	var goods = this.activeOrder.goodsList[index];
    	if( goods.handling_fee <= 0 ){
    		return;
    	}
    	var _av = this;
    	window.request('post', _av.params.reduceprice_url, {order_id:this.activeOrder.orderId, stock_goods_id:goods.stock_goods_id}, false, function(data){
    		if( !data.code || data.code != 1 ){
                           
                return Alert(data.message ? data.message : '操作失败');
            }
    		_av.activeOrder.goodsList[index].price = data.data.price;
    		_av.activeOrder.goodsList[index].reduce_price = data.data.reduce_price;
    		_av.orderList[_av.orderIndex].goodsList = _av.activeOrder.goodsList;
    		_av.updateFootTotal();
        });
    	return;
    	
    	
    	var reduce_price = 0;
    	goods.price = parseFloat(goods.price);
    	goods.handling_fee = parseFloat(goods.handling_fee);
    	
    	if( goods.unit == 'JINBOXES' ){
    		//取得优惠的价格
			reduce_price = Math.floor(goods.handling_fee * goods.boxes / goods.weight * 100) / 100;
			if( reduce_price<=0 ) return;
			
    		if( goods.reduce_price>0 ){
    			goods.price = floatadd(goods.price, reduce_price);
    			goods.reduce_price = 0;
    		}else{
    			if( goods.price<=reduce_price ){
    				return Alert('商品单价必须大于下车费单价');
    			}
    			goods.price = floatsub(goods.price, reduce_price);
    			goods.reduce_price = reduce_price;
    		}
    	}else{
    		reduce_price = goods.handling_fee;
    		if( reduce_price<=0 ) return;
    		
    		if( goods.reduce_price>0 ){
    			goods.price = floatadd(goods.price, reduce_price);
    			goods.reduce_price = 0;
    		}else{
    			if( goods.price<=goods.handling_fee ){
    				return Alert('商品单价必须大于下车费单价');
    			}
    			goods.price = floatsub(goods.price, reduce_price);
    			goods.reduce_price = reduce_price;
    		}
    	} 
    	this.activeOrder.goodsList[index] = goods;
    	this.orderList[this.orderIndex].goodsList = this.activeOrder.goodsList;
    	this.updateFootTotal();
    },
    
	//删除一个商品
    removeGoodsItemConfirm: function(index){
    	var _av = this;
    	Confirm('您确定要删除它吗?', function(isok){
			if( !isok ){
				return;
			}
			_av.removeGoodsItem(index);
		});
    },
    removeGoodsItem: function(index){
    	var _av = this;
        var removeGoods = _av.orderList[_av.orderIndex].goodsList.splice(index, 1);
        _av.showOrder();
        _av.updateFootTotal();
        _av.saveOrderToLocalStorage();
        if( _av.activeOrder.orderId > 0 ){
            //删除服务器上
        	window.request('post', _av.params.removegoods_url, {
        		order_id:_av.activeOrder.orderId, 
        		stock_goods_id:removeGoods[0].stock_goods_id
        	}, false, function(data){
        		if( !data.code || data.code != 1 ){
                    return Alert(data.message ? data.message : '操作失败', 500, function(){});
                }
        		_av.getstockList();
                //Alert('删除成功');
        	});
        }
    },
    
    //清空商品
    clearGoods: function(){
    	var _av = this;
        _av.orderList[_av.orderIndex].goodsList = [];
        _av.showOrder();
        _av.updateFootTotal();
        _av.saveOrderToLocalStorage();
    },
    
    //初始化
    init: function(){
        var _av = this;
        $(window).on('avalon-start', function(e, data){
            //开始
            _av.params = data;
            _av.getstockList();
            
            //选择用户
            _av.selectuser.init(_av, _av.params.selectuser_url, function(data){
            	if(data){
            		_av.setUser(data.id, data.name);
            	}
            });
            
            //添加商品
            _av.addgoods.init(_av, '', function(data){
            	if(!data){
            		return;
            	}
            	
            	//验证是否存在该商品
                for(var i=0; i<_av.activeOrder.goodsList.length; i++){
                    if( _av.activeOrder.goodsList[i].stock_goods_id == data.stock_goods_id ){
                        if( _av.modifyIndex >= 0 && _av.modifyIndex == i ){
                            //如果是修改，为正常的
                            continue;
                        }
                        return Alert('该商品已存在');
                    }
                }
                
                if( _av.modifyIndex >= 0 ){
                    _av.modifyGoodsFun(data);
                }else{
                	data.reduce_price = 0;
                	_av.addGoodsFun(data);
                }  
            });
            
            //添加用户
            _av.adduser.init(_av, _av.params.adduser_url, function(data){
                if(data) _av.selectuser.getuserList();
            });
            
            //结算
            _av.settlement.init(_av, _av.params.settlement_url, function(data){
                if(data){
                	//删除当前订单
                	_av.removeOrder(_av.orderIndex, false);
                	_av.addNewTempOrder();
                }
            });
            
            //从网络获取订单列表
            window.request('get', _av.params.order_list_url, {}, false, function(data){
            	if( !data.code || data.code != 1 ){
                    return Alert(data.message ? data.message : '获取订单列表失败');
                }
                
                //更新本地预订的列表
                _av.updateLocalOrderList( data.data.list );
                _av.showOrder();
                _av.showUserBalance(_av.activeOrder.customerId);
            });
        })
        .on('popup-show-click', function(e, data){
            //进入场景
            var $popup = $(data.popupname),
            	scene = $popup.data('scene');
            if( scene == 'addgoods' ){
        		//添加商品
        		_av.modifyIndex = -1;
        	}
            _av[$popup.data('scene')].into($popup.get(0));
        })
        .on('popup-mask-click', function(e, data){
            //退出场景
            _av[ $(data.popup).data('scene') ].exit( data.popup );
        })
        .on('keyup', function(e){
            //事件分别进入到当前场景的处理函数
            var sceneName = _av.sceneStack[_av.sceneStack.length-1];
            if( _av.sceneName == sceneName ){
                _av.keyup(e.keyCode);

            }else if( _av[sceneName] && _av[sceneName].sceneName == sceneName ){
                _av[sceneName].keyup(e.keyCode);
            }
            e.keyCode=0;
            e.returnValue = false;
        })
        .on('resize', function(){
        	_av.updateOrderNameSwiper();
        });
        
        //从本地获取临时订单
        _av.getOrderListFromLocalStorage();
        setTimeout(function(){
            _av.updateOrderNameSwiper();
        }, 300);
    }
});
_avalon.addgoods = {
    sceneName: 'addgoods',
    unit: 'JIN',     //默认类型为以斤
    stock: 0,
    isfirst: true,
    
    //默认
    input_boxes: '',
    input_weight: '',
    default_price: '',
    default_handling_fee: '',
    
    //铵钮处理
    keyup: function(keyCode){
        switch(keyCode){
            case 13://ENTER
                this.formSubmit();
                break;
            case 27://ESC
                this.exit();
                break;
        }
    },
    
    //进入
    into: function(popup, selectpicker_type){
        var _av = this,
        	$popup = popup ? $(popup) : $('#addgoods-popup');
        	
        $popup.show();
        if( window.device=='ios' ) $('body').addClass('ios-popup-fixed');
        //var $select = $('#selectinput-stock-goods');
        
        if( selectpicker_type == 'disabled' ){
            $('#selectinput-stock-goods').attr('disabled', true);//禁用
        }else if( selectpicker_type == 'none' ){
            
        }else{
        	//弹出
        	setTimeout(function(){
        		if( _av.isfirst ){
            		$('#selectinput-stock-goods').selectpicker('toggle').selectpicker('refresh');
            	}else{
            		$('#selectinput-stock-goods').selectpicker('toggle');
            	}
        		_av.isfirst = false;
        	}, 100);
        	
        }
        _avalon.sceneStack.push(this.sceneName);
    },
    
    //退出
    exit: function(popup, data){
        var $popup = popup ? $(popup) : $('#addgoods-popup');
        $popup.hide();
        if( window.device=='ios' ) $('body').removeClass('ios-popup-fixed'); 
        if( window.device=='ios' && window.pack=='app' && (document.activeElement.nodeName == 'INPUT' || document.activeElement.nodeName == 'SELECT' || document.activeElement.nodeName == 'TEXTAREA') ) document.activeElement.blur();
        //this.input_boxes = '';
        //this.input_weight = '';
        this.default_price = '';
        this.default_handling_fee = '';
        $('#selectinput-stock-goods').val('').attr('disabled', false).selectpicker('refresh');
        $('#addgoods-boxes').val('');
        $('#addgoods-weight').val('');
        this.unit = 'JIN';
        _avalon.sceneStack.pop();
        
        if( typeof(this.callback) == 'function' ){
            this.callback(data);
        }
    },
    
    
    //选择了商品
    selectgoods: function(e){
    	var $select = $(e.currentTarget).find('option:selected');
        this.unit = $select.data('unit');
        this.stock = this.unit == 'JIN' ? parseInt($select.data('surplus_weight')) : parseInt($select.data('surplus_boxes'));
        this.default_price = $select.data('price');
        this.default_handling_fee = $select.data('handling_fee');
        $('#addgoods-'+ (this.unit == 'JIN'?'weight':'boxes') ).focus();
    },
    
    selectgoodsForSide: function(id, unit, surplus_weight, surplus_boxes, price, handling_fee){
        //进入并显示添加商品层
        this.into('', 'none');
        //选中商品品
        $('#selectinput-stock-goods').val(id).selectpicker('render').selectpicker('refresh');
        this.unit = unit;
        this.stock = unit == 'JIN' ? surplus_weight : surplus_boxes;
        this.default_price = price;
        this.default_handling_fee = handling_fee;
        $('#addgoods-'+ (this.unit == 'JIN'?'weight':'boxes') ).focus();
    },
    
    //添加表单提交
    formSubmit: function(){
        var $form = $('form[name="addgoods-form"]'),
            $goods = $form.find('select[name="stock_goods_id"]'),
            formdata = {
                stock_goods_id: $goods.val(),
                goods_name: $goods.find('option:selected').text(),
                unit: this.unit,
                boxes: $form.find('input[name="boxes"]').val(),
                weight: $form.find('input[name="weight"]').val() || 0,
                price: $form.find('input[name="price"]').val() || 0,//单价可不填
                handling_fee: $form.find('input[name="handling_fee"]').val()
            };
        //验证
        if( formdata.stock_goods_id <= 0 ){
            return;
        }
        if( this.unit == 'JIN' ){
            if( !isPInt(formdata.weight) ){
            	$('#addgoods-weight').focus();
            	return;// Alert('请填写正确的重量')
            }
        }
        if( this.unit == 'BOXES' ){
            if( !isPInt(formdata.boxes) ){
            	$('#addgoods-boxes').focus();
            	return;// Alert('请填写正确的件数')
            }
        }
        if( this.unit != 'JIN' ){
        	if( !isPInt(formdata.boxes) ){
        		$('#addgoods-boxes').focus();
            	return;// Alert('请填写正确的件数')
        	}
        	if( !isInt(formdata.weight) || formdata.weight<0 ){
        		$('#addgoods-weight').focus();
            	return;// Alert('请填写正确的重量')
        	}
        }
        if( (!isInt(formdata.price) && !isFloat(formdata.price)) || formdata.price<0 ){
            return Alert('请填写正确的单价');
        }
        if( !isInt(formdata.handling_fee) && !isFloat(formdata.handling_fee) || formdata.handling_fee<0 ){
            return Alert('请填写正确的下车费');
        }
        
        this.exit('', formdata);
    },
    
    //修改商品
    modifyGoodsItem: function(goods){
        this.unit = goods.unit;   
        
        //显示添加商品层
        this.into('', 'disabled');
        
        //选中商品品
        $('#selectinput-stock-goods').val(goods.stock_goods_id).selectpicker('render').attr('disabled', true);
        $('#addgoods-boxes').val( goods.boxes );
        $('#addgoods-weight').val( goods.weight );
        $('#addgoods-price').val( goods.price );
        $('#addgoods-handling-fee').val( goods.handling_fee );
    },

    //初始化
    init: function(av, url, callback){
        var _this = this;
        _this.url = url;
        _this.callback = callback;
        
        $('#addgoods-btn-submit').click(function(){
            _this.formSubmit();
        });
        $('#addgoods-btn-cancel').click(function(){
            _this.exit();
        });
    }
};
_avalon.selectorders = {
    sceneName: 'selectorders',
    
    //铵钮处理
    keyup: function(keyCode){
        switch(keyCode){
            case 27://ESC
                this.exit();
                break; 
        }
    },
    
    //进入
    into: function(popup){
        var $popup = popup ? $(popup) : $('#selectorders-popup')
        $popup.show();
        if( window.device=='ios' ) $('body').addClass('ios-popup-fixed');
        _avalon.sceneStack.push(this.sceneName);
    },
    
    //退出
    exit: function(popup, data){
        var $popup = popup ? $(popup) : $('#selectorders-popup')
        $popup.hide();
        if( window.device=='ios' ) $('body').removeClass('ios-popup-fixed');
        if( window.device=='ios' && window.pack=='app' && (document.activeElement.nodeName == 'INPUT' || document.activeElement.nodeName == 'SELECT' || document.activeElement.nodeName == 'TEXTAREA') ) document.activeElement.blur();
        _avalon.sceneStack.pop();
    },
    
	//初始化
    init: function(){
    }
};
//显示找补
avalon.filters.showGiveChange = function(collectAmount,totalAmount,discountAmount) {
	var totalAmount100 = Math.round(totalAmount * 100);
	var discountAmount100 = Math.round(discountAmount * 100);
	var collectAmount100 = Math.round(collectAmount * 100);
	if( collectAmount && collectAmount100 > totalAmount100 - discountAmount100 ){
		return (collectAmount100 - (totalAmount100 - discountAmount100)) / 100;
	}
    return '--';
}

_avalon.settlement = {
    sceneName: 'settlement',
    totalAmount: 0,      //订单总金额
    discountAmount: '',  //优惠金额
    collectAmount: '',    //实收金额
    paytype: 'CASH',     //支付方式, 默认现金
    
    //铵钮处理
    keyup: function(keyCode){
        switch(keyCode){
            case 27://ESC
                this.exit();
                break; 
        }
    },
    
    //进入
    into: function(popup){
        var $popup = popup ? $(popup) : $('#settlement-popup')
        $popup.show();
        if( window.device=='ios' ) $('body').addClass('ios-popup-fixed');
        if( window.device!='ios' || window.pack!='app') $('#settlement-collect').focus();
        _avalon.sceneStack.push(this.sceneName);
        //$('#settlement-discount').val('');
        
        //计算价格
        this.totalAmount = parseFloat($('#foot-total').text());
        this.collectAmount = '';
        this.paytype = 'CASH';
        this.discountAmount = parseInt(this.totalAmount) < this.totalAmount ? parseFloat((this.totalAmount - parseInt(this.totalAmount)).toFixed(2)) : '';
    },
    
    //退出
    exit: function(popup, data){
        var $popup = popup ? $(popup) : $('#settlement-popup')
        $popup.hide();
        if( window.device=='ios' ) $('body').removeClass('ios-popup-fixed');
        if( window.device=='ios' && window.pack=='app' && (document.activeElement.nodeName == 'INPUT' || document.activeElement.nodeName == 'SELECT' || document.activeElement.nodeName == 'TEXTAREA') ) document.activeElement.blur();
        _avalon.sceneStack.pop();
        if( typeof(this.callback) == 'function' ){
            this.callback(data);
        }
    },
    
    //提交表单
    formSubmit: function(){
    	var _this = this;
    	var $form = $('form[name="settlement-form"]'),
    		orderId = parseInt($form.find('input[name="settlement-order-id"]').val());
    	if( isNaN(orderId) || orderId<1 ){
    		return Alert('错误的订单');
    	}
        if( this.discountAmount < 0 || this.discountAmount > this.totalAmount ){
            return Alert('优惠金额有误');
        }
        if( this.paytype == 'CASH' ){
            if( !this.collectAmount || this.collectAmount < 0 ){
                return Alert('请填写正确的实收金额');
            }
        }
        
        var $btn = $('#settlement-btn-submit');
        $btn.button('loading');
        window.request('post', this.url, {
            order_id: orderId, 
            discount: this.discountAmount, 
            collect: this.collectAmount, 
            paytype: this.paytype
        }, false, function(data){
        	$btn.button('reset');
        	if( !data.code || data.code != 1 ){
                return Alert(data.message ? data.message : '结算失败');
            }
            
            Alert('结算成功',  500);
            if( window.settings && window.settings.order_settlement_print == 1 ){
            	toPrint('order', {id:orderId}); 
            }
            _this.exit('', {orderId:orderId});
        });
    },
    
    validate: {
        onError: function (reasons) {
            var err = false;
            reasons.forEach(function (reason) {
                if( reason.element.name == 'discount' ){
                    reason.element.value = 0;
                }else{
                    err = true;
                }
            });
            
            if(err) $('#settlement-submit').attr('disabled', true);
        },
        onSuccess: function(){
            $('#settlement-submit').attr('disabled', false);
        },
        onValidateAll: function (reasons) {
            if (reasons.length) {
                console.log('有表单没有通过')
            } else {
                console.log('全部通过')
            }
        }
    },
    
	//初始化
    init: function(av, url, callback){
        var _this = this;
        _this.url = url;
        _this.callback = callback;
        
        $('#settlement-btn-submit').click(function(){
            _this.formSubmit();
        });
        $('#settlement-btn-cancel').click(function(){
            _this.exit();
        });
    }
};
_avalon.selectuser = {
    sceneName: 'selectuser',
    url: '',
    callback: null,
    userList: null,	    //用户列表
    pinyinSwiper: null,	//拼音滚动
    searchResult: [],	//搜索结果
    labelResult: [],	//标签结果
    selectLoc: '',      //默认选择位置
    selectIndex: -1,    //选择项的索引
    
    
    getuserList: function(){
        var _this = this;
        //获取所有用户
        window.request('get', _this.url, {}, false, function(data){
        	if( !data.code || data.code != 1 ){
                return Alert(data.message ? data.message : '获取用户数据失败');
            }
        	
        	if( data.data ){
	            _this.userList = data.data;
	            
	            //触发第一项
	            _this.navPinyinTab($('.nav-pinyin a.active').get(0));
        	}
        });
    },
    
    //铵钮处理
    keyup: function(keyCode){
        switch(keyCode){
            case 27://ESC
                this.exit();
                break; 
            case 37://左
                this.move('left');
                break; 
            case 38://上
                this.move('top');
                break; 
            case 39://右
                this.move('right');
                break; 
            case 40://下
                this.move('bottom');
                break; 
            case 112://F1
                $('.selectuser-keyup-f1').trigger('click');
                break;
        }
    },
    
    //进入
    into: function(popup){
        var $popup = popup ? $(popup) : $('#selectuser-popup');
        $popup.show();
        if( window.device=='ios' ) $('body').addClass('ios-popup-fixed');
        if( window.device!='ios' || window.pack!='app') $popup.find('#user-search-input').focus();
        _avalon.sceneStack.push(this.sceneName);
    },
    
    //退出
    exit: function(popup){
        var $popup = popup ? $(popup) : $('#selectuser-popup');
        $popup.hide();
        if( window.device=='ios' ) $('body').removeClass('ios-popup-fixed');
        if( window.device=='ios' && window.pack=='app' && (document.activeElement.nodeName == 'INPUT' || document.activeElement.nodeName == 'SELECT' || document.activeElement.nodeName == 'TEXTAREA') ) document.activeElement.blur();
        $popup.find('#user-search-input').val('');
        this.userSearchFun('');
        _avalon.sceneStack.pop();
    },
    
    move: function(type){
        //@todo 位置移动
    },
    
    //搜索初始化
    init: function(av, url, callback){ 	
    	var _this = this;
    	_this.url = url;
        _this.callback = callback;
    	_this.getuserList();
        
        //拼音滚动
    	_this.pinyinSwiper = new Swiper('.nav-pinyin', {
            pagination: '.swiper-pagination',
            slidesPerView: 'auto',
            paginationClickable: true,
            spaceBetween: 30,
            freeMode: true,
        });
        
        $('.nav-pinyin a').click(function(){
        	_this.navPinyinTab(this);
        });
    },
    
    //搜索框事件处理
    userSearch: function(e, isNoIme){
    	if( isNoIme ){
    		if( !this.$usersearchshow ) this.$usersearchshow = $('#user-search-input-show');
    		this.$usersearchshow.val(e.currentTarget.value);
    	}
    	this.userSearchFun(e.currentTarget.value);
    },
    
    userSearchFun: function(str){
    	if( str == '' ){
            $('.pinyin-box').show();
            $('.search-list-result').hide();
        }else{
            $('.pinyin-box').hide();
            $('.search-list-result').show();
            var valArr = str.replace(' ','-').split('-');
            
            //搜索数据
            this.searchResult = [];
            for( var i in this.userList ){
                if( this.userList[i].key.indexOf(valArr[0]) == 0 ){
                    if( valArr.length==2 ){
                        for( var j=0; j<this.userList[i].children.length; j++ ){
                            if( this.userList[i].children[j].key.indexOf(valArr[1]) == 0 ){
                                this.searchResult.push({
                                    id: this.userList[i].children[j].id, 
                                    name: i +' '+ this.userList[i].children[j].name
                                });
                            }
                        }
                    }else{
                        for( var j=0; j<this.userList[i].children.length; j++ ){
                            this.searchResult.push({
                                id: this.userList[i].children[j].id, 
                                name: i +' '+ this.userList[i].children[j].name
                            });
                        }
                    }
                }
            }

            if( this.searchResult.length>0 ){
                $('.search-list-result .nodata').hide();
            }else{
                $('.search-list-result .nodata').show();
            }
        }
    },
    
    //拼音点击
    navPinyinTab: function(target){
        var letters = target.innerHTML;
        $(target).addClass('active').siblings().removeClass('active');
        this.labelResult = [];
        if( $.isEmptyObject(this.userList) ){
        	return;
        }
        if( letters=='标签' ){
            for( var label_name in this.userList ){
                this.labelResult.push({name:label_name});
            }
        }
        else if( letters=='ABCD' ){
            for( var label_name in this.userList ){
                var k = this.userList[label_name].key;
                if( k.indexOf('a')==0 || k.indexOf('b')==0 || k.indexOf('b')==0 || k.indexOf('b')==0 ){
                    this.labelResult.push({name:label_name});
                }
            }
        }
        else if( letters=='EFGH' ){
            for( var label_name in this.userList ){
                var k = this.userList[label_name].key;
                if( k.indexOf('e')==0 || k.indexOf('f')==0 || k.indexOf('g')==0 || k.indexOf('h')==0 ){
                    this.labelResult.push({name:label_name});
                }
            }
        }
        else if( letters=='IJKL' ){
            for( var label_name in this.userList ){
                var k = this.userList[label_name].key;
                if( k.indexOf('i')==0 || k.indexOf('j')==0 || k.indexOf('k')==0 || k.indexOf('l')==0 ){
                    this.labelResult.push({name:label_name});
                }
            }
        }
        else if( letters=='MNOP' ){
            for( var label_name in this.userList ){
                var k = this.userList[label_name].key;
                if( k.indexOf('m')==0 || k.indexOf('n')==0 || k.indexOf('o')==0 || k.indexOf('p')==0 ){
                    this.labelResult.push({name:label_name});
                }
            }
        }
        else if( letters=='QRST' ){
            for( var label_name in this.userList ){
                var k = this.userList[label_name].key;
                if( k.indexOf('q')==0 || k.indexOf('r')==0 || k.indexOf('s')==0 || k.indexOf('t')==0 ){
                    this.labelResult.push({name:label_name});
                }
            }
        }
        else if( letters=='UVWX' ){
            for( var label_name in this.userList ){
                var k = this.userList[label_name].key;
                if( k.indexOf('u')==0 || k.indexOf('v')==0 || k.indexOf('w')==0 || k.indexOf('x')==0 ){
                    this.labelResult.push({name:label_name});
                }
            }
        }
        else if( letters=='YZ' ){
            for( var label_name in this.userList ){
                var k = this.userList[label_name].key;
                if( k.indexOf('y')==0 || k.indexOf('z')==0 ){
                    this.labelResult.push({name:label_name});
                }
            }
        }
    },
    
    //拼音变大
    navPinyinFocus: function(e){
        if( !$(e.currentTarget).hasClass('max') ){
            $(e.currentTarget).addClass('max');
            //更新拼音滚动
            this.pinyinSwiper.updateSlidesSize();
        }
    },
    
    //标签被选择事件处理
    labelSelect: function(e){
        $(e.currentTarget).addClass('active').siblings().removeClass('active');
        this.searchResult = [];
        for( var label_name in this.userList ){
            if( '<span>'+label_name+'</span>' == e.currentTarget.innerHTML ){
                for( var i=0; i<this.userList[label_name].children.length; i++ ){
                    this.searchResult.push({
                        id: this.userList[label_name].children[i].id, 
                        name: label_name +' '+ this.userList[label_name].children[i].name
                    });
                }
            }
        }
        
        $('.search-list-result').show();
        if( this.searchResult.length>0 ){
            $('.search-list-result .nodata').hide();
        }else{
            $('.search-list-result .nodata').show();
        }
    },
    
    //结果被选择事件处理
    searchResultSelect: function(e, id, name){
        this.exit();
        if(this.callback) this.callback({id:id, name:name});
    },
};
_avalon.adduser = {
    sceneName: 'adduser',
    url: '',
    modifydata: null,
    modifyurl: '',
    callback: null,
    
    //铵钮处理
    keyup: function(keyCode){
        switch(keyCode){
            case 13://ENTER
                this.formSubmit();
                break;
            case 27://ESC
                this.exit();
                break;              
        }
    },
    
    //进入
    into: function(popup, modifydata, modifyurl){
    	this.modifydata = modifydata;
    	if( this.modifydata ){
    		this.modifyurl = modifyurl;
    		$('#adduser-label').val(modifydata.label);
    		$('#adduser-name').val(modifydata.name);
    		$('#adduser-mobile').val(modifydata.mobile);
    	}
    	
        var $popup = popup ? $(popup) : $('#adduser-popup');
        $popup.show();
        if( window.device=='ios' ) $('body').addClass('ios-popup-fixed');
        if( window.device!='ios' || window.pack!='app') $('#adduser-label').focus();
        _avalon.sceneStack.push(this.sceneName);
    },
    
    //退出
    exit: function(popup, data){
        var $popup = popup ? $(popup) : $('#adduser-popup');
        $popup.hide();
        if( window.device=='ios' ) $('body').removeClass('ios-popup-fixed');
        if( window.device=='ios' && window.pack=='app' && (document.activeElement.nodeName == 'INPUT' || document.activeElement.nodeName == 'SELECT' || document.activeElement.nodeName == 'TEXTAREA') ) document.activeElement.blur();
        $('form[name="adduser-form"]').get(0).reset();
        _avalon.sceneStack.pop();
        if( typeof(this.callback) == 'function' ){
            this.callback(data);
        }
    },
    
    //提交表单
    formSubmit: function(){
        var _this = this;
        var $form = $('form[name="adduser-form"]'),
        	$mobile = $form.find('input[name="mobile"]'),
        	mobile_allow_empty = $mobile.hasClass('allow-empty'),
            formdata = {
                label: $form.find('input[name="label"]').val(),
                name: $form.find('input[name="name"]').val(),
                mobile: $mobile.val(),
            };
        //验证
        if( formdata.label.length < 2 ){
            return Alert('请填写正确的标签');
        }
        if( formdata.name.length < 2 ){
            return Alert('请填写正确的名称');
        }
        if( !mobile_allow_empty && !formdata.mobile ){
        	return Alert('请填写正确的手机号');
        }
        if( formdata.mobile ){
	        var mobile_re = /^1\d{10}$/;
	    	if( !mobile_re.test(formdata.mobile) ){
	    		return Alert('请填写正确的手机号');
	        }
        }
        //修改时添加id
        if( _this.modifydata ){
        	formdata.id = _this.modifydata.id;
        }
        var $btn = $('#adduser-btn-submit');
        $btn.button('loading');
        window.request('post', _this.modifydata ? _this.modifyurl : _avalon.params.adduser_url, formdata, false, function(data){
        	$btn.button('reset');
        	if( !data.code || data.code != 1 ){
                return Alert(data.message ? data.message : '操作失败');
            }
            
            Alert('操作成功');                        
            _this.exit('', formdata);
        });
    },
    
    //初始化
    init: function(av, url, callback){
        var _this = this;
        _this.url = url;
        _this.callback = callback;
        $('#adduser-btn-submit').click(function(){
            _this.formSubmit();
        });
        $('#adduser-btn-cancel').click(function(){
            _this.exit();
        });
    }
};
_avalon.init();