var _avalon = avalon.define({
    $id: 'pagecontroller',
    sceneName: 'main',
    sceneStack: ['main'],   //场景堆栈（当前场景显示在最后面）
    params: null,           //传入的参数
    pageData: {},
    
    //获取数据
    getData: function(url){
    	var _av = this;
    	
    	window.request('get', url, {}, false, function(data){
        	if( !data.code || data.code != 1 ){
				return Alert(data.message ? data.message : '获取数据失败');
			}
			_av.pageData = data.data;
    	});
    },
    
	//提交表单
    formSubmit: function(){
        var _this = this;
        var $form = $('form[name="settings-form"]'),
        	mobile_re = /^1\d{10}$/,
        	phone_re = /^0\d{2,3}-?\d{7,8}$/,
            formdata = {
        		merchant_name: $form.find('input[name="merchant_name"]').val(),
        		merchant_phone: $form.find('input[name="merchant_phone"]').val(),
        		
        		order_settlement_print: $form.find('#order_settlement_print').hasClass('open') ? 1 : 0,
        		stock_settlement_print: $form.find('#stock_settlement_print').hasClass('open') ? 1 : 0,
        		customer_repayment_print: $form.find('#customer_repayment_print').hasClass('open') ? 1 : 0,
        		merchant_repayment_print: $form.find('#merchant_repayment_print').hasClass('open') ? 1 : 0,
        		
        		order_settlement_sms: $form.find('#order_settlement_sms').hasClass('open') ? 1 : 0,
        		stock_settlement_sms: $form.find('#stock_settlement_sms').hasClass('open') ? 1 : 0,
        		customer_repayment_sms: $form.find('#customer_repayment_sms').hasClass('open') ? 1 : 0,
        		merchant_repayment_sms: $form.find('#merchant_repayment_sms').hasClass('open') ? 1 : 0,
            };
        //验证
        if( !formdata.merchant_name || formdata.merchant_name.length<3 ){
            return Alert('请填写正确的商户名称');
        }
        if( !mobile_re.test(formdata.merchant_phone) && !phone_re.test(formdata.merchant_phone) ){
            return Alert('请填写正确的商户电话');
        }
        
        window.request('post', _this.params.submit_url, formdata, false, function(data){
        	if( !data.code || data.code != 1 ){
                return Alert(data.message ? data.message : '操作失败');
            }
            Alert('设置成功');
            
            //更新本地
            setMemberData(data.data.member);
        });
    },
    
    
    init: function(){
    	var _av = this;
        $(window).on('avalon-start', function(e, data){
            //开始
            _av.params = data;
            _av.getData(_av.params.main_url);
            
            $('#settings-btn-submit').click(function(){
            	_av.formSubmit();
            });
        })
        .on('popup-show-click', function(e, data){
            //进入场景
            var $popup = $(data.popupname);
            _av[$popup.data('scene')].into($popup.get(0), data.popupdata);
        })
        .on('popup-mask-click', function(e, data){
            //退出场景
            _av[ $(data.popup).data('scene') ].exit( data.popup );
        })
        .on('keyup', function(e){
            //事件分别进入到当前场景的处理函数
            var sceneName = _av.sceneStack[_av.sceneStack.length-1];
            if( _av.sceneName == sceneName ){
                if(_av.keyup) _av.keyup(e.keyCode);

            }else if( _av[sceneName] && _av[sceneName].sceneName == sceneName ){
                if(_av[sceneName] && _av[sceneName].keyup) _av[sceneName].keyup(e.keyCode);
            }
            e.keyCode=0;
            e.returnValue = false;
        });
    }
});
_avalon.init();