var _avalon = avalon.define({
    $id: 'pagecontroller',
    sceneName: 'main',
    sceneStack: ['main'],   //场景堆栈（当前场景显示在最后面）
    params: null,           //传入的参数
    goodsList: [],		    //商品列表
    suplierId: 0,           //货主ID
    
    selectUserName: '',
    
    adduser: null,
    selectuser: null,
    addgoods: null,
    
    keyup: function(keyCode){
        switch(keyCode){
            case 120://F9
                $('.main-keyup-f9').trigger('click');
                break;
            case 122://F11
                $('.main-keyup-f11').trigger('click');
                break;
            case 123://F12
                if( goodsList.length>0 ){
                    this.saveToServer();
                }
                break;
        }
    },
    
    //重置场景
    resetScene: function(){
        this.goodsList = [];
        this.suplierId = 0;
        this.selectUserName = '';
    },
    
    //入库提交到服务器
    saveToServer: function(e){
        var _av = this;
        
        var $btn = $('#btn-add-save');
        $btn.button('loading');
        window.request('post', _av.params.save_url, {
            supplier_id: _av.suplierId, 
            goods_list: JSON.stringify(_av.goodsList)
        }, false, function(data){
        	$btn.button('reset');
        	if( !data.code || data.code != 1 ){
                return Alert(data.message ? data.message : '操作失败');
            }
            
            Alert('库存保存成功');
            _av.resetScene();
        });
        return false;
    },
    
	//更新下部总数
    updateFootTotal: function(){
        var goodsTotal = 0,
            handlingfeeTotal = 0;
        for( var i=0; i<this.goodsList.length; i++ ){
            if( this.goodsList[i].unit == 'JIN' ){
                goodsTotal += this.goodsList[i].total_weight * this.goodsList[i].price;
                handlingfeeTotal += this.goodsList[i].total_weight * this.goodsList[i].handling_fee;
            }else{
                goodsTotal += this.goodsList[i].total_boxes * this.goodsList[i].price;
                handlingfeeTotal += this.goodsList[i].total_boxes * this.goodsList[i].handling_fee;
            }
        }
        $('#foot-addto').html('&yen;'+goodsTotal);
        $('#foot-handlingfee').html('&yen;'+handlingfeeTotal);
        $('#foot-total').html('&yen;'+(goodsTotal+handlingfeeTotal));
    },
    
	//删除一个商品
    removeGoodsItem: function(index){
        this.goodsList.splice(index, 1);
        this.updateFootTotal();
    },
    
    //清空商品
    clearGoods: function(){
    	this.goodsList = [];
        this.updateFootTotal();
    },

    //初始化
    init: function(){
        var _av = this;
        $(window).on('avalon-start', function(e, data){
            //开始
            _av.params = data;
            
            //选择用户
            _av.selectuser.init(_av, _av.params.selectuser_url, function(data){
                if(data){
                	_av.suplierId = data.id;
                	_av.selectUserName = data.name;
                	_av.selectuser.getuserList();
                }
            });
            
            //添加商品
            _av.addgoods.init(_av, '', function(data){
            	if(data){
            		//验证是否存在该商品
                    for(var i=0; i<_av.goodsList.length; i++){
                        if( _av.goodsList[i].name == data.name ){
                            return Alert('该商品已存在');
                        }
                    }            		
            		
            		_av.goodsList.push(data);
            		_av.updateFootTotal();
            	}
            });
            
            //添加用户
            _av.adduser.init(_av, _av.params.adduser_url, function(data){
                if(data) _av.selectuser.getuserList();
            });
        })
        .on('popup-show-click', function(e, data){
            //进入场景
            var $popup = $(data.popupname)
            _av[$popup.data('scene')].into($popup.get(0));
        })
        .on('popup-mask-click', function(e, data){
            //退出场景
            _av[ $(data.popup).data('scene') ].exit( data.popup );
        })
        .on('keyup', function(e){
            //事件分别进入到当前场景的处理函数
            var sceneName = _av.sceneStack[_av.sceneStack.length-1];
            if( _av.sceneName == sceneName ){
                _av.keyup(e.keyCode);

            }else if( _av[sceneName] && _av[sceneName].sceneName == sceneName ){
                _av[sceneName].keyup(e.keyCode);
            }
            e.keyCode=0;
            e.returnValue = false;
        });
    }
});
_avalon.addgoods = {
    sceneName: 'addgoods',
    unit: 'JINBOXES', //默认类型为以斤件
    modifyIndex: -1,  //修改的商品索引  
    
    url: '', 
    callback: null,
    
    //铵钮处理
    keyup: function(keyCode){
        switch(keyCode){
            case 13://ENTER
                this.formSubmit();
                break;
            case 27://ESC
                this.exit();
                break;
        }
    },
    
    //进入
    into: function(popup){
        var $popup = popup ? $(popup) : $('#addgoods-popup');
        $popup.show();
        if( window.device=='ios' ) $('body').addClass('ios-popup-fixed');
        if( window.device!='ios' || window.pack!='app') $popup.find('input[name="name"]').focus();
        _avalon.sceneStack.push(this.sceneName);
    },
    
    //退出
    exit: function(popup){
        var $popup = popup ? $(popup) : $('#addgoods-popup');
        $popup.hide();
        if( window.device=='ios' ) $('body').removeClass('ios-popup-fixed');
        if( window.device=='ios' && window.pack=='app' && (document.activeElement.nodeName == 'INPUT' || document.activeElement.nodeName == 'SELECT' || document.activeElement.nodeName == 'TEXTAREA') ) document.activeElement.blur();
        $('form[name="addgoods-form"]').get(0).reset(); 
        this.unit = 'JINBOXES';
        _avalon.sceneStack.pop();
    },
    
    //添加表单提交
    formSubmit: function(){
        var $form = $('form[name="addgoods-form"]'),
            formdata = {
                name: $form.find('input[name="name"]').val(),
                unit: $form.find('select[name="unit"]').val(),
                total_boxes: $form.find('input[name="total_boxes"]').val(),
                total_weight: $form.find('input[name="total_weight"]').val(),
                price: $form.find('input[name="price"]').val(),
                handling_fee: $form.find('input[name="handling_fee"]').val()
            };
        //验证
        if( formdata.name.length < 2 ){
            return Alert('请填写正确的名称');
        }
        if( formdata.unit == 'JIN' ){
            if( !isPInt(formdata.total_weight) ){
                return Alert('请填写正确的重量');
            }
        }else{
            if( !isPInt(formdata.total_boxes) ){
                return Alert('请填写正确的件数');
            }    			
        }    		
        if( !isPInt(formdata.price) && !isPFloat(formdata.price) ){
            return Alert('请填写正确的单价');
        }
        if( !isPInt(formdata.handling_fee) && !isPFloat(formdata.handling_fee) ){
            return Alert('请填写正确的下车费');
        }
        
        /*/验证是否存在该商品
        for(var i=0; i<_avalon.goodsList.length; i++){
            if( _avalon.goodsList[i].name == formdata.name ){
                return Alert('该商品已存在');
            }
        }*/
        
        if( this.callback ){
        	this.callback( formdata );
        }
        
        this.exit();
    },
        
    //初始化
    init: function(av, url, callback){
        var _this = this;
        _this.url = url;
        _this.callback = callback;
        
        $('#addgoods-btn-submit').click(function(){
            _this.formSubmit();
        });
        $('#addgoods-btn-cancel').click(function(){
            _this.exit();
        });
    }
};
_avalon.selectuser = {
    sceneName: 'selectuser',
    url: '',
    callback: null,
    userList: null,	    //用户列表
    pinyinSwiper: null,	//拼音滚动
    searchResult: [],	//搜索结果
    labelResult: [],	//标签结果
    selectLoc: '',      //默认选择位置
    selectIndex: -1,    //选择项的索引
    
    
    getuserList: function(){
        var _this = this;
        //获取所有用户
        window.request('get', _this.url, {}, false, function(data){
        	if( !data.code || data.code != 1 ){
                return Alert(data.message ? data.message : '获取用户数据失败');
            }
        	
        	if( data.data ){
	            _this.userList = data.data;
	            
	            //触发第一项
	            _this.navPinyinTab($('.nav-pinyin a.active').get(0));
        	}
        });
    },
    
    //铵钮处理
    keyup: function(keyCode){
        switch(keyCode){
            case 27://ESC
                this.exit();
                break; 
            case 37://左
                this.move('left');
                break; 
            case 38://上
                this.move('top');
                break; 
            case 39://右
                this.move('right');
                break; 
            case 40://下
                this.move('bottom');
                break; 
            case 112://F1
                $('.selectuser-keyup-f1').trigger('click');
                break;
        }
    },
    
    //进入
    into: function(popup){
        var $popup = popup ? $(popup) : $('#selectuser-popup');
        $popup.show();
        if( window.device=='ios' ) $('body').addClass('ios-popup-fixed');
        if( window.device!='ios' || window.pack!='app') $popup.find('#user-search-input').focus();
        _avalon.sceneStack.push(this.sceneName);
    },
    
    //退出
    exit: function(popup){
        var $popup = popup ? $(popup) : $('#selectuser-popup');
        $popup.hide();
        if( window.device=='ios' ) $('body').removeClass('ios-popup-fixed');
        if( window.device=='ios' && window.pack=='app' && (document.activeElement.nodeName == 'INPUT' || document.activeElement.nodeName == 'SELECT' || document.activeElement.nodeName == 'TEXTAREA') ) document.activeElement.blur();
        $popup.find('#user-search-input').val('');
        this.userSearchFun('');
        _avalon.sceneStack.pop();
    },
    
    move: function(type){
        //@todo 位置移动
    },
    
    //搜索初始化
    init: function(av, url, callback){ 	
    	var _this = this;
    	_this.url = url;
        _this.callback = callback;
    	_this.getuserList();
        
        //拼音滚动
    	_this.pinyinSwiper = new Swiper('.nav-pinyin', {
            pagination: '.swiper-pagination',
            slidesPerView: 'auto',
            paginationClickable: true,
            spaceBetween: 30,
            freeMode: true,
        });
        
        $('.nav-pinyin a').click(function(){
        	_this.navPinyinTab(this);
        });
    },
    
    //搜索框事件处理
    userSearch: function(e, isNoIme){
    	if( isNoIme ){
    		if( !this.$usersearchshow ) this.$usersearchshow = $('#user-search-input-show');
    		this.$usersearchshow.val(e.currentTarget.value);
    	}
    	this.userSearchFun(e.currentTarget.value);
    },
    
    userSearchFun: function(str){
    	if( str == '' ){
            $('.pinyin-box').show();
            $('.search-list-result').hide();
        }else{
            $('.pinyin-box').hide();
            $('.search-list-result').show();
            var valArr = str.replace(' ','-').split('-');
            
            //搜索数据
            this.searchResult = [];
            for( var i in this.userList ){
                if( this.userList[i].key.indexOf(valArr[0]) == 0 ){
                    if( valArr.length==2 ){
                        for( var j=0; j<this.userList[i].children.length; j++ ){
                            if( this.userList[i].children[j].key.indexOf(valArr[1]) == 0 ){
                                this.searchResult.push({
                                    id: this.userList[i].children[j].id, 
                                    name: i +' '+ this.userList[i].children[j].name
                                });
                            }
                        }
                    }else{
                        for( var j=0; j<this.userList[i].children.length; j++ ){
                            this.searchResult.push({
                                id: this.userList[i].children[j].id, 
                                name: i +' '+ this.userList[i].children[j].name
                            });
                        }
                    }
                }
            }

            if( this.searchResult.length>0 ){
                $('.search-list-result .nodata').hide();
            }else{
                $('.search-list-result .nodata').show();
            }
        }
    },
    
    //拼音点击
    navPinyinTab: function(target){
        var letters = target.innerHTML;
        $(target).addClass('active').siblings().removeClass('active');
        this.labelResult = [];
        if( $.isEmptyObject(this.userList) ){
        	return;
        }
        if( letters=='标签' ){
            for( var label_name in this.userList ){
                this.labelResult.push({name:label_name});
            }
        }
        else if( letters=='ABCD' ){
            for( var label_name in this.userList ){
                var k = this.userList[label_name].key;
                if( k.indexOf('a')==0 || k.indexOf('b')==0 || k.indexOf('b')==0 || k.indexOf('b')==0 ){
                    this.labelResult.push({name:label_name});
                }
            }
        }
        else if( letters=='EFGH' ){
            for( var label_name in this.userList ){
                var k = this.userList[label_name].key;
                if( k.indexOf('e')==0 || k.indexOf('f')==0 || k.indexOf('g')==0 || k.indexOf('h')==0 ){
                    this.labelResult.push({name:label_name});
                }
            }
        }
        else if( letters=='IJKL' ){
            for( var label_name in this.userList ){
                var k = this.userList[label_name].key;
                if( k.indexOf('i')==0 || k.indexOf('j')==0 || k.indexOf('k')==0 || k.indexOf('l')==0 ){
                    this.labelResult.push({name:label_name});
                }
            }
        }
        else if( letters=='MNOP' ){
            for( var label_name in this.userList ){
                var k = this.userList[label_name].key;
                if( k.indexOf('m')==0 || k.indexOf('n')==0 || k.indexOf('o')==0 || k.indexOf('p')==0 ){
                    this.labelResult.push({name:label_name});
                }
            }
        }
        else if( letters=='QRST' ){
            for( var label_name in this.userList ){
                var k = this.userList[label_name].key;
                if( k.indexOf('q')==0 || k.indexOf('r')==0 || k.indexOf('s')==0 || k.indexOf('t')==0 ){
                    this.labelResult.push({name:label_name});
                }
            }
        }
        else if( letters=='UVWX' ){
            for( var label_name in this.userList ){
                var k = this.userList[label_name].key;
                if( k.indexOf('u')==0 || k.indexOf('v')==0 || k.indexOf('w')==0 || k.indexOf('x')==0 ){
                    this.labelResult.push({name:label_name});
                }
            }
        }
        else if( letters=='YZ' ){
            for( var label_name in this.userList ){
                var k = this.userList[label_name].key;
                if( k.indexOf('y')==0 || k.indexOf('z')==0 ){
                    this.labelResult.push({name:label_name});
                }
            }
        }
    },
    
    //拼音变大
    navPinyinFocus: function(e){
        if( !$(e.currentTarget).hasClass('max') ){
            $(e.currentTarget).addClass('max');
            //更新拼音滚动
            this.pinyinSwiper.updateSlidesSize();
        }
    },
    
    //标签被选择事件处理
    labelSelect: function(e){
        $(e.currentTarget).addClass('active').siblings().removeClass('active');
        this.searchResult = [];
        for( var label_name in this.userList ){
            if( '<span>'+label_name+'</span>' == e.currentTarget.innerHTML ){
                for( var i=0; i<this.userList[label_name].children.length; i++ ){
                    this.searchResult.push({
                        id: this.userList[label_name].children[i].id, 
                        name: label_name +' '+ this.userList[label_name].children[i].name
                    });
                }
            }
        }
        
        $('.search-list-result').show();
        if( this.searchResult.length>0 ){
            $('.search-list-result .nodata').hide();
        }else{
            $('.search-list-result .nodata').show();
        }
    },
    
    //结果被选择事件处理
    searchResultSelect: function(e, id, name){
        this.exit();
        if(this.callback) this.callback({id:id, name:name});
    },
};
_avalon.adduser = {
    sceneName: 'adduser',
    url: '',
    modifydata: null,
    modifyurl: '',
    callback: null,
    
    //铵钮处理
    keyup: function(keyCode){
        switch(keyCode){
            case 13://ENTER
                this.formSubmit();
                break;
            case 27://ESC
                this.exit();
                break;              
        }
    },
    
    //进入
    into: function(popup, modifydata, modifyurl){
    	this.modifydata = modifydata;
    	if( this.modifydata ){
    		this.modifyurl = modifyurl;
    		$('#adduser-label').val(modifydata.label);
    		$('#adduser-name').val(modifydata.name);
    		$('#adduser-mobile').val(modifydata.mobile);
    	}
    	
        var $popup = popup ? $(popup) : $('#adduser-popup');
        $popup.show();
        if( window.device=='ios' ) $('body').addClass('ios-popup-fixed');
        if( window.device!='ios' || window.pack!='app') $('#adduser-label').focus();
        _avalon.sceneStack.push(this.sceneName);
    },
    
    //退出
    exit: function(popup, data){
        var $popup = popup ? $(popup) : $('#adduser-popup');
        $popup.hide();
        if( window.device=='ios' ) $('body').removeClass('ios-popup-fixed');
        if( window.device=='ios' && window.pack=='app' && (document.activeElement.nodeName == 'INPUT' || document.activeElement.nodeName == 'SELECT' || document.activeElement.nodeName == 'TEXTAREA') ) document.activeElement.blur();
        $('form[name="adduser-form"]').get(0).reset();
        _avalon.sceneStack.pop();
        if( typeof(this.callback) == 'function' ){
            this.callback(data);
        }
    },
    
    //提交表单
    formSubmit: function(){
        var _this = this;
        var $form = $('form[name="adduser-form"]'),
        	$mobile = $form.find('input[name="mobile"]'),
        	mobile_allow_empty = $mobile.hasClass('allow-empty'),
            formdata = {
                label: $form.find('input[name="label"]').val(),
                name: $form.find('input[name="name"]').val(),
                mobile: $mobile.val(),
            };
        //验证
        if( formdata.label.length < 2 ){
            return Alert('请填写正确的标签');
        }
        if( formdata.name.length < 2 ){
            return Alert('请填写正确的名称');
        }
        if( !mobile_allow_empty && !formdata.mobile ){
        	return Alert('请填写正确的手机号');
        }
        if( formdata.mobile ){
	        var mobile_re = /^1\d{10}$/;
	    	if( !mobile_re.test(formdata.mobile) ){
	    		return Alert('请填写正确的手机号');
	        }
        }
        //修改时添加id
        if( _this.modifydata ){
        	formdata.id = _this.modifydata.id;
        }
        var $btn = $('#adduser-btn-submit');
        $btn.button('loading');
        window.request('post', _this.modifydata ? _this.modifyurl : _avalon.params.adduser_url, formdata, false, function(data){
        	$btn.button('reset');
        	if( !data.code || data.code != 1 ){
                return Alert(data.message ? data.message : '操作失败');
            }
            
            Alert('操作成功');                        
            _this.exit('', formdata);
        });
    },
    
    //初始化
    init: function(av, url, callback){
        var _this = this;
        _this.url = url;
        _this.callback = callback;
        $('#adduser-btn-submit').click(function(){
            _this.formSubmit();
        });
        $('#adduser-btn-cancel').click(function(){
            _this.exit();
        });
    }
};
_avalon.init();