var _avalon = avalon.define({
    $id: 'pagecontroller',
    sceneName: 'main',
    sceneStack: ['main'],   //场景堆栈（当前场景显示在最后面）
    params: null,           //传入的参数
    pageData: {
    	status				: 0,
    	goods_list			: [],//列表
        stock				: null,
        goods_amount		: 0,	//总货款
        discount_amount		: 0,	//优惠
		handling_fee_amount	: 0,	//下车费
		arrears_amount		: 0,
		cash_amount			: 0,
		wechatpay_amount	: 0,
		alipay_amount		: 0,
		
		expense_payment		: 0,	//费用支付
		settlement_amount	: 0,	//结算费用
    },
    
    //合并代码
    feeset: null,
    addgoods: null,
    goodsmodify: null,
    
    //获取数据, onlyGetList:是否仅获取列表
    getData: function(url, onlyGetList){
    	var _av = this;
    	
    	window.request('get', url ? url : _av.params.main_url, {}, false, function(data){
        	if( !data.code || data.code != 1 ){
				return Alert(data.message ? data.message : '获取数据失败');
			}
			_av.pageData.goods_list = data.data.goods_list;
			if( onlyGetList ){
				return;
			}
			_av.pageData.stock = data.data.stock;
			_av.pageData.status = data.data.stock.status;
			
			_av.pageData.goods_amount = data.data.goods_amount;
			_av.pageData.discount_amount = data.data.discount_amount;
			_av.pageData.handling_fee_amount = data.data.handling_fee_amount;
			_av.pageData.arrears_amount = data.data.arrears_amount;
			_av.pageData.cash_amount = data.data.cash_amount;
			_av.pageData.wechatpay_amount = data.data.wechatpay_amount;
			_av.pageData.alipay_amount = data.data.alipay_amount;
			
			if( data.data.stock && data.data.stock.agency_fee ){
				_av.pageData.expense_payment = parseFloat(data.data.stock.agency_fee) + parseFloat(data.data.stock.freight_fee) + parseFloat(data.data.stock.entrance_fee) + parseFloat(data.data.stock.other_fee);
				_av.pageData.expense_payment = _av.pageData.expense_payment.toFixed(2) - 0;
			}
			
			_av.showPayChart();
    	});
    },
    
    //显示支付的图表
    showPayChart: function(){
    	var config = {
	        type: 'doughnut',
	        data: {
	            datasets: [{
	                data: [
	                    this.pageData.arrears_amount,
	                    this.pageData.cash_amount,
	                    this.pageData.wechatpay_amount,
	                    this.pageData.alipay_amount,
	                ],
	                backgroundColor: [
	                    'rgb(255, 99, 132)',
	                    'rgb(255, 159, 64)',
	                    'rgb(70,195,123)',
	                    'rgb(72,176,247)',
	                ],
	                label: 'Dataset 1'
	            }],
	            labels: ["赊销","现金","微信","支付宝"]
	        },
	        options: {
	            responsive: true,
	            maintainAspectRatio: false,
	            legend: {
	                position: 'bottom',
	                labels: {
	                	boxWidth: 10,
	                }
	            },
	            title: {
	                display: false,
	                text: '各支付方式'
	            },
	            animation: {
	                animateScale: true,
	                animateRotate: true
	            }
	        }
	    };
    	if( !window.myDoughnut ){
    		var ctx = document.getElementById("chart-area").getContext("2d");
        	window.myDoughnut = new Chart(ctx, config);
    	}
    },
    
    //结算
    settlement: function(){
    	var _av = this;
    	if( _av.pageData.stock.agency_fee <= 0 ){
    		return Alert('请先设置代办费');
    	}
    	if( _av.pageData.stock.freight_fee <= 0){
    		return Alert('请先设置运费');
    	}
    	
    	var $btn = $('#settlement-btn');
        $btn.button('loading');
    	window.request('post', _av.params.settlement_url, {}, false, function(data){
    		$btn.button('reset');
        	if( !data.code || data.code != 1 ){
				return Alert(data.message ? data.message : '操作失败');
			}
			
			Alert('操作成功');    			
			_av.pageData.status = 'SETTLED';
    	});
    },
    //调整按钮点击
    goodsmodifyClick: function(goods){
    	this.goodsmodify.into(null, goods);
    },
	//删除按钮点击
    goodsremoveClick: function(goods){
    	var _av = this;
    	Confirm('您确认要删除此商品?', function(isok){
    		if( !isok ){
    			return;
    		}
    		
    		window.request('post', _av.params.goodsremove_url, {goods_id:goods.id}, false, function(data){
       			if( !data.code || data.code != 1 ){
    				return Alert(data.message ? data.message : '操作失败');
    			}
    			
    			Alert('操作成功');
    			
    			//显示新列表
    			_av.getData('', true);
       		});
    	});
    },
    init: function(){
    	var _av = this;
        $(window).on('avalon-start', function(e, data){
            //开始
            _av.params = data;
            _av.feeset.init(_av, _av.params.feeset_url, function(data){
            	if( !data ) return;
                //设置成功
            	_av.pageData.stock.agency_fee = data.agency_fee;
            	_av.pageData.stock.freight_fee = data.freight_fee;
            	_av.pageData.stock.entrance_fee = data.entrance_fee;
            	_av.pageData.stock.other_fee = data.other_fee;
            	_av.pageData.stock.note = data.note;
            	
            	//显示新列表
            	_av.getData('');
            });
            
            //添加商品
            _av.addgoods.init(_av, '', function(data){
            	if(data){ 
            		//验证是否存在该商品
                    for(var i=0; i<_av.pageData.goods_list.length; i++){
                        if( _av.pageData.goods_list[i].name == data.name ){
                            return Alert('该商品已存在');
                        }
                    } 
                    
                    //提交到服务器
                    var $btn = $('#addgoods-btn-submit');
                    $btn.button('loading');
                    window.request('post', _av.params.goodsadd_url, data, false, function(data){
                    	$btn.button('reset');
                    	if( !data.code || data.code != 1 ){
            				return Alert(data.message ? data.message : '获取数据失败');
            			}
                    	//显示新列表
                    	_av.getData('', true);
                    });
            	}
            });
            
            _av.goodsmodify.init(_av, _av.params.goodsmodify_url, function(data){
            	if( !data ) return;
            	
            	//设置成功
            	for( var i=0; i<_av.pageData.goods_list.length; i++ ){
            		if( _av.pageData.goods_list[i].id == data.id ){
            			_av.pageData.goods_list[i].price = data.price;
            			_av.pageData.goods_list[i].handling_fee = data.handling_fee;
            			if( _av.pageData.goods_list[i].unit == 'JIN' ){
            				_av.pageData.goods_list[i].total_weight += data.quantity;
            				_av.pageData.goods_list[i].surplus_weight += data.quantity;
            			}else{
            				_av.pageData.goods_list[i].total_boxes += data.quantity;
            				_av.pageData.goods_list[i].surplus_boxes += data.quantity;
            			}
            		}
            	}
            	
            	//显示新列表
            	//_av.getData('', true);
            });
            _av.getData();
            
            $('#settlement-btn').click(function(){
            	if( _av.pageData.stock && _av.pageData.stock.status != 50 ){
            		Confirm('您确认要结算吗？', function(isok){
            			if( isok ) _av.settlement();
            		});
	            }
            });
        })
        .on('popup-show-click', function(e, data){
            //进入场景
            var $popup = $(data.popupname);
            _av[$popup.data('scene')].into($popup.get(0), data.popupdata);
        })
        .on('popup-mask-click', function(e, data){
            //退出场景
            _av[ $(data.popup).data('scene') ].exit( data.popup );
        })
        .on('keyup', function(e){
            //事件分别进入到当前场景的处理函数
            var sceneName = _av.sceneStack[_av.sceneStack.length-1];
            if( _av.sceneName == sceneName ){
                if(_av.keyup) _av.keyup(e.keyCode);

            }else if( _av[sceneName] && _av[sceneName].sceneName == sceneName ){
                if(_av[sceneName] && _av[sceneName].keyup) _av[sceneName].keyup(e.keyCode);
            }
            e.keyCode=0;
            e.returnValue = false;
        });
    }
});
_avalon.feeset = {
    sceneName: 'feeset', 
    callback: null,
    submiturl: '',
    
    //铵钮处理
    keyup: function(keyCode){
        switch(keyCode){
            case 13://ENTER
                this.formSubmit();
                break;
            case 27://ESC
                this.exit();
                break;              
        }
    },
    
    //进入
    into: function(popup){
        var $popup = popup ? $(popup) : $('#feeset-popup');
        $popup.show();
        if( window.device=='ios' ) $('body').addClass('ios-popup-fixed');
        if( window.device!='ios' || window.pack!='app') $popup.find('input[name="agency_fee"]').focus();
        _avalon.sceneStack.push(this.sceneName);
    },
    
    //退出
    exit: function(popup, data){
        var $popup = popup ? $(popup) : $('#feeset-popup');
        $popup.hide();
        if( window.device=='ios' ) $('body').removeClass('ios-popup-fixed');
        if( window.device=='ios' && window.pack=='app' && (document.activeElement.nodeName == 'INPUT' || document.activeElement.nodeName == 'SELECT' || document.activeElement.nodeName == 'TEXTAREA') ) document.activeElement.blur();
        //$('form[name="feeset-form"]').get(0).reset(); 
        _avalon.sceneStack.pop();
        if( typeof(this.callback) == 'function' ){
            this.callback(data);
        }
    },
    
    //提交表单
    formSubmit: function(){
        var _this = this;
        var $form = $('form[name="feeset-form"]'),
            formdata = {
	        	agency_fee: $form.find('input[name="agency_fee"]').val(),
	        	freight_fee: $form.find('input[name="freight_fee"]').val(),
	        	entrance_fee: $form.find('input[name="entrance_fee"]').val(),
	        	other_fee: $form.find('input[name="other_fee"]').val(),
	        	note: $form.find('input[name="note"]').val()
            };
        //验证
        if( formdata.agency_fee && !isPInt(formdata.agency_fee) && !isPFloat(formdata.agency_fee) && formdata.agency_fee!=='0' ){
            return Alert('请填写正确的代理费');
        }
        if( formdata.freight_fee && !isPInt(formdata.freight_fee) && !isPFloat(formdata.freight_fee) && formdata.freight_fee!=='0' ){
            return Alert('请填写正确的运费');
        }
        if( formdata.entrance_fee && !isPInt(formdata.entrance_fee) && !isPFloat(formdata.entrance_fee) && formdata.entrance_fee!=='0' ){
            return Alert('请填写正确的进门费');
        }
        if( formdata.other_fee && !isPInt(formdata.other_fee) && !isPFloat(formdata.other_fee) && formdata.other_fee!=='0' ){
            return Alert('请填写正确的杂费');
        }
        
        var $btn = $('#feeset-btn-submit');
        $btn.button('loading');
        window.request('post', _this.submiturl, formdata, false, function(data){
        	$btn.button('reset');
        	if( !data.code || data.code != 1 ){
                return Alert(data.message ? data.message : '操作失败');
            }
            
            Alert('设置成功');
            _this.exit('', formdata);
        });
    },
    
    //初始化
    init: function(av, url, callback){
        var _this = this;
        _this.submiturl = url;
        _this.callback = callback;
        $('#feeset-btn-submit').click(function(){
            _this.formSubmit();
        });
        $('#feeset-btn-cancel').click(function(){
            _this.exit();
        });
    }
};
_avalon.goodsmodify = {
    sceneName: 'goodsmodify', 
    callback: null,
    submiturl: '',
    indata: {
    	id: 0,
    	goods_name: '',
    	unit: 'JIN',
    	price: 0,
    	handling_fee: 0,
    	total_weight: 0,
    	surplus_weight: 0,
    	total_boxes: 0,
    	surplus_boxes: 0,
    },
    
    //铵钮处理
    keyup: function(keyCode){
        switch(keyCode){
            case 13://ENTER
                this.formSubmit();
                break;
            case 27://ESC
                this.exit();
                break;              
        }
    },
    
    //进入
    into: function(popup, indata){
        var $popup = popup ? $(popup) : $('#goodsmodify-popup');
        $popup.show();
        if( window.device=='ios' ) $('body').addClass('ios-popup-fixed');
        
        this.indata = indata;
        //if( window.device!='ios' || window.pack!='app') $popup.find('input[name="agency_fee"]').focus();
        _avalon.sceneStack.push(this.sceneName);
    },
    
    //退出
    exit: function(popup, data){
        var $popup = popup ? $(popup) : $('#goodsmodify-popup');
        $popup.hide();
        if( window.device=='ios' ) $('body').removeClass('ios-popup-fixed');
        if( window.device=='ios' && window.pack=='app' && (document.activeElement.nodeName == 'INPUT' || document.activeElement.nodeName == 'SELECT' || document.activeElement.nodeName == 'TEXTAREA') ) document.activeElement.blur();
        //$('form[name="goodsmodify-form"]').get(0).reset(); 
        _avalon.sceneStack.pop();
        if( typeof(this.callback) == 'function' ){
            this.callback(data);
        }
    },
    
    //提交表单
    formSubmit: function(){
        var _this = this;
        var $form = $('form[name="goodsmodify-form"]'),
            formdata = {
        		id: _this.indata.id,
	        	price: parseFloat($form.find('input[name="price"]').val()),
	        	handling_fee: parseFloat($form.find('input[name="handling_fee"]').val()),
	        	quantity: parseInt($form.find('input[name="quantity"]').val())
            };
        //验证
        if( isNaN(formdata.price) || formdata.price<=0 ){
            return Alert('请填写正确的单价');
        }
        if( isNaN(formdata.handling_fee) || formdata.handling_fee<0 ){
            return Alert('请填写正确的下车费');
        }
        
        //验证库存
        if( isNaN(formdata.quantity) ){
        	formdata.quantity = 0;
        }
        if( _this.indata.unit == 'JIN' ){
        	if( formdata.quantity < 0 && _this.indata.surplus_weight < formdata.quantity ){
        		return Alert('该商品库存不足');
        	}
        }else{
        	if( formdata.quantity < 0 && _this.indata.surplus_boxes < formdata.quantity ){
        		return Alert('该商品库存不足');
        	}
        }
        
        var $btn = $('#goodsmodify-btn-submit');
        $btn.button('loading');
        window.request('post', _this.submiturl, formdata, false, function(data){
        	$btn.button('reset');
            if( !data.code || data.code != 1 ){
                return Alert(data.message ? data.message : '操作失败');
            }
            
            Alert('设置成功');
            _this.exit('', formdata);
        });
    },
    
    //初始化
    init: function(av, url, callback){
        var _this = this;
        _this.submiturl = url;
        _this.callback = callback;
        $('#goodsmodify-btn-submit').click(function(){
            _this.formSubmit();
        });
        $('#goodsmodify-btn-cancel').click(function(){
            _this.exit();
        });
    }
};
_avalon.addgoods = {
    sceneName: 'addgoods',
    unit: 'JINBOXES', //默认类型为以斤件
    modifyIndex: -1,  //修改的商品索引  
    
    url: '', 
    callback: null,
    
    //铵钮处理
    keyup: function(keyCode){
        switch(keyCode){
            case 13://ENTER
                this.formSubmit();
                break;
            case 27://ESC
                this.exit();
                break;
        }
    },
    
    //进入
    into: function(popup){
        var $popup = popup ? $(popup) : $('#addgoods-popup');
        $popup.show();
        if( window.device=='ios' ) $('body').addClass('ios-popup-fixed');
        if( window.device!='ios' || window.pack!='app') $popup.find('input[name="name"]').focus();
        _avalon.sceneStack.push(this.sceneName);
    },
    
    //退出
    exit: function(popup){
        var $popup = popup ? $(popup) : $('#addgoods-popup');
        $popup.hide();
        if( window.device=='ios' ) $('body').removeClass('ios-popup-fixed');
        if( window.device=='ios' && window.pack=='app' && (document.activeElement.nodeName == 'INPUT' || document.activeElement.nodeName == 'SELECT' || document.activeElement.nodeName == 'TEXTAREA') ) document.activeElement.blur();
        $('form[name="addgoods-form"]').get(0).reset(); 
        this.unit = 'JINBOXES';
        _avalon.sceneStack.pop();
    },
    
    //添加表单提交
    formSubmit: function(){
        var $form = $('form[name="addgoods-form"]'),
            formdata = {
                name: $form.find('input[name="name"]').val(),
                unit: $form.find('select[name="unit"]').val(),
                total_boxes: $form.find('input[name="total_boxes"]').val(),
                total_weight: $form.find('input[name="total_weight"]').val(),
                price: $form.find('input[name="price"]').val(),
                handling_fee: $form.find('input[name="handling_fee"]').val()
            };
        //验证
        if( formdata.name.length < 2 ){
            return Alert('请填写正确的名称');
        }
        if( formdata.unit == 'JIN' ){
            if( !isPInt(formdata.total_weight) ){
                return Alert('请填写正确的重量');
            }
        }else{
            if( !isPInt(formdata.total_boxes) ){
                return Alert('请填写正确的件数');
            }    			
        }    		
        if( !isPInt(formdata.price) && !isPFloat(formdata.price) ){
            return Alert('请填写正确的单价');
        }
        if( !isPInt(formdata.handling_fee) && !isPFloat(formdata.handling_fee) ){
            return Alert('请填写正确的下车费');
        }
        
        /*/验证是否存在该商品
        for(var i=0; i<_avalon.goodsList.length; i++){
            if( _avalon.goodsList[i].name == formdata.name ){
                return Alert('该商品已存在');
            }
        }*/
        
        if( this.callback ){
        	this.callback( formdata );
        }
        
        this.exit();
    },
        
    //初始化
    init: function(av, url, callback){
        var _this = this;
        _this.url = url;
        _this.callback = callback;
        
        $('#addgoods-btn-submit').click(function(){
            _this.formSubmit();
        });
        $('#addgoods-btn-cancel').click(function(){
            _this.exit();
        });
    }
};
_avalon.init();